#include "colors.inc"

#declare wood_tone = color rgb<0.32,0.18,0.14>;
#declare wood_mid = color rgb<0.30,0.16,0.12>;
#declare wood_line = color rgb <0.20,0.06,0.04>;

#ifdef (SIMPLE_TEXTURE)
#declare shelf_wood = texture { pigment { Brown } }
#declare brick_t = texture { pigment { rgb<0.28,0.1,0.09> } }
#declare mortar_t = texture { pigment { White } }

#else
#declare shelf_wood = texture {
	pigment { 
		wood
		color_map { 
			[ 0  color wood_tone ]
			[0.25 color wood_tone ]
			[0.95 color wood_mid ]
			[ 1 color wood_line ]
		}
	 	turbulence <0.06,0.03,0.03> 
		octaves 3
		rotate <0, 90,0> 
		translate <0,0,20>
		warp {
			black_hole <3,3,3>, 3
			turbulence <4,4,4>
			repeat <10,10,10>
			inverse
		}
		warp {
			black_hole <4,4,4>, 4
			repeat <10,10,10>
			turbulence <2,2,2>
		}
		warp {
			black_hole <15,15,15>, 15
			turbulence <10,10,10>
			repeat <40,40,40>
			inverse
		}
		scale 0.25
	}
	finish {
		diffuse 0.65
		brilliance 2.0
	}
}

#declare brick_t = texture {
	pigment {
		dents
		color_map {
			[ 0 color rgb<0.45,0.08,0.06> ]
			[1 color Black]
		}
 		turbulence <0.2,0.2,0.2>
		scale 0.25
	}
	normal {
		dents
 		turbulence <0.2,0.2,0.2>
		scale 0.25
	}
	finish {
		diffuse 0.3
		specular 0.05
		roughness 0.15
	}
}

#declare mortar_t = texture {
	pigment {
		color rgb < 0.1,0.1,0.1 >
	}
	normal {
		dents 
		turbulence 0.3
		scale < 0.22, 0.22, 0.22>
	}
	finish {
		diffuse 0.2
		specular 0.15
		roughness 0.35
	}
}
#end

#declare cutter = prism {
		linear_sweep
		cubic_spline
		-37, 37,
		16,
		<-0.25,-0.25>, <0.25,-0.25> , <-1.875,-0.25>, <-1.875,-0.25>, 
		<-1.875,0.15>, <-1.875,0.15>, <-1.35,0.25>, <-1.02,0.75>,
		//<-0.96,0.95>, 
		<-0.90, 1.15>, <-0.65, 1.65>, <-0.25, 1.875>, <-0.25, 1.875>,
		<0.25,1.875>, <0.25,1.875>, <0.25,-0.25>, <0.25,-0.5>
		rotate < 0,0,90 > 
	}

#declare shelf = intersection {
	box {
		<30,1,12>, <-30,-1,-6>
	}
 	object { 
		cutter 
		inverse
		translate < 0, 1, -6>
	}
 	object { 
		cutter 
		inverse
		rotate < 0, 90, 0 >
		translate < -30, 1, 0 >
	}
 	object { 
		cutter 
		inverse
		rotate < 0, -90, 0 >
		translate < 30, 1, 0 >
	}
}
